#include <stdio.h>
#include <stdlib.h>
#include <check.h>

#include "arith.h"


/** PUBLIC TESTS **/

START_TEST (add_pos)
{ ck_assert_int_eq(add_abs(2, 3), 5); }
END_TEST




/** GENERIC TEST SUITE CODE **/

Suite * test_suite(void)
{
    Suite *s;
    TCase *tc_core;
    s = suite_create("Default");
    tc_core = tcase_create("Core");

    tcase_add_test(tc_core, add_pos);


    // add_abs new tests here

    suite_add_tcase(s, tc_core);
    return s;
}

int run_testsuite()
{
    int number_failed;
    Suite *s;
    SRunner *sr;

    s = test_suite();
    sr = srunner_create(s);

    srunner_run_all(sr, CK_NORMAL);
    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);

    if (number_failed == 0) {
        printf("SUCCESS: All current tests passed!\n");
    } else {
        printf("FAILURE: At least one test failed or crashed.\n");
    }

    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
}

int main(int argc, char* argv[])
{
    return run_testsuite();
}

